// ՓAPIQ

#pragma once

namespace IKD
{

///////////////////////////////////////////////////
// p[eBNՓ˔EEʒuZo֐
//   rA          : p[eBNA̔a
//   rB          : p[eBNB̔a
//   pre_pos_A   : p[eBNȂÖʒu
//   pos_A       : p[eBNA̎̓Bʒu
//   pre_pos_B   : p[eBNB̑Oʒu
//   pos_B       : p[eBNB̎̓Bʒu
//   pout_t      : ՓˎԂi[FLOAT^ւ̃|C^
//   pout_colli_A : p[eBNȀՓˈʒui[D3DXVECTOR^ւ̃|C^
//   pout_colli_B : p[eBNȀՓˈʒui[D3DXVECTOR^ւ̃|C^

bool CheckParticleCollision(
   FLOAT rA, FLOAT rB, 
   D3DXVECTOR3 *pPre_pos_A, D3DXVECTOR3 *pPos_A,
   D3DXVECTOR3 *pPre_pos_B, D3DXVECTOR3 *pPos_B,
   FLOAT *pOut_t,
   D3DXVECTOR3 *pOut_colli_A,
   D3DXVECTOR3 *pOut_colli_B
)
{
   // OʒuyѓBʒuɂp[eBNԂ̃xNgZo
   D3DXVECTOR3 C0 = *pPre_pos_B - *pPre_pos_A;
   D3DXVECTOR3 C1 = *pPos_B - *pPos_A;
   D3DXVECTOR3 D = C1 - C0;

   // Փ˔p2֐W̎Zo
   FLOAT P = D3DXVec3LengthSq( &D ); if(P<=0) return false; // Ɉړ
   FLOAT Q = D3DXVec3Dot( &C0, &D ); if(Q==0) return false; // s
   FLOAT R = D3DXVec3LengthSq( &C0 );

   // p[eBN
   FLOAT r = rA + rB;

   // Փ˔莮
   FLOAT Judge = Q*Q - P*(R-r*r);
   if( Judge < 0 ){
      // Փ˂ĂȂ
      return false;
   }

   // ՓˎԂ̎Zo
   FLOAT t_plus = (-Q + sqrt(Judge))/P;
   FLOAT t_minus = (-Q - sqrt(Judge))/P;

   // ՓˎԂ01傫ꍇAՓ˂Ȃ
//   if( (t_plus < 0 || t_plus > 1) && (t_minus < 0 || t_minus > 1)) return false;
   if(t_minus < 0 || t_minus > 1) return false;

   // ՓˎԂ̌it_minusɍŏ̏Փˁj
   *pOut_t = t_minus;

   // Փˈʒǔ
   *pOut_colli_A = *pPre_pos_A + t_minus * (*pPos_A - *pPre_pos_A);
   *pOut_colli_B = *pPre_pos_B + t_minus * (*pPos_B - *pPre_pos_B);

   return true; // Փ˕
}




///////////////////////////////////////////////////
// p[eBNՓˌ㑬xʒuZo֐
//   pColliPos_A : Փ˒̃p[eBNA̒Sʒu
//   pVelo_A     : Փ˂̏uԂ̃p[eBNȂx
//   pColliPos_B : Փ˒̃p[eBNB̒Sʒu
//   pVelo_B     : Փ˂̏uԂ̃p[eBNB̑x
//   weight_A    : p[eBNA̎
//   weight_B    : p[eBNB̎
//   res_A       : p[eBNA̔
//   res_B       : p[eBNB̔
//   time        : ˌ̈ړ\
//   pOut_pos_A  : p[eBNA̔ˌʒu
//   pOut_velo_A : p[eBNA̔ˌ㑬xxNg
//   pOut_pos_B  : p[eBNB̔ˌʒu
//   pOut_velo_B : p[eBNB̔ˌ㑬xxNg
bool CalcParticleColliAfterPos(
   D3DXVECTOR3 *pColliPos_A, D3DXVECTOR3 *pVelo_A,
   D3DXVECTOR3 *pColliPos_B, D3DXVECTOR3 *pVelo_B,
   FLOAT weight_A, FLOAT weight_B,
   FLOAT res_A, FLOAT res_B,
   FLOAT time,
   D3DXVECTOR3 *pOut_pos_A, D3DXVECTOR3 *pOut_velo_A,
   D3DXVECTOR3 *pOut_pos_B, D3DXVECTOR3 *pOut_velo_B
)
{
   FLOAT TotalWeight = weight_A + weight_B; // ʂ̍v
   FLOAT RefRate = (1 + res_A*res_B); // 
   D3DXVECTOR3 C = *pColliPos_B - *pColliPos_A; // ՓˎxNg
   D3DXVec3Normalize(&C, &C);
   FLOAT Dot = D3DXVec3Dot( &(*pVelo_A-*pVelo_B), &C ); // ώZo
   D3DXVECTOR3 ConstVec = RefRate*Dot/TotalWeight * C; // 萔xNg

   // Փˌ㑬xxNg̎Zo
   *pOut_velo_A = -weight_B * ConstVec + *pVelo_A;
   *pOut_velo_B = weight_A * ConstVec + *pVelo_B;

   // Փˌʒu̎Zo
   *pOut_pos_A = *pColliPos_A + time * (*pOut_velo_A);
   *pOut_pos_B = *pColliPos_B + time * (*pOut_velo_B);

   return true;
}


///////////////////////////////////////////////////
// ʃp[eBNՓ˔EEʒuZo֐
//   r          : p[eBN̔a
//   pPre_pos   : p[eBN̑Öʒu
//   pPos       : p[eBN̎̓Bʒu
//   pNormal    : ʂ̖@
//   pPlane_pos : ʏ1_
//   pOut_t     : ՓˎԂi[FLOAT^ւ̃|C^
//   pOut_colli : p[eBN̏Փˈʒui[D3DXVECTOR^ւ̃|C^

bool CheckParticlePlaneCollision(
   FLOAT r,
   D3DXVECTOR3 *pPre_pos, D3DXVECTOR3 *pPos,
   D3DXVECTOR3 *pNormal, D3DXVECTOR3 *pPlane_pos,
   FLOAT *t,
   D3DXVECTOR3 *pOut_colli
)
{
   D3DXVECTOR3 C0 = *pPre_pos - *pPlane_pos; // ʏ̈_猻݈ʒuւ̃xNg
   D3DXVECTOR3 D = *pPos - *pPre_pos; // ݈ʒu\ʒu܂ł̃xNg
   D3DXVECTOR3 N; // @
   D3DXVec3Normalize(&N, pNormal); // @W

   // Փ˔
   FLOAT Dot = D3DXVec3Dot( &D, &N );
   if( Dot >= 0 )
      return false; // Ȃ

   // Ԃ̎Zo
   FLOAT Dot_C0 = D3DXVec3Dot( &C0, &N );
   *t = ( r - Dot_C0 )/Dot;

   // Փˈʒu̎Zo
   *pOut_colli = *pPre_pos + (*t) * D;

   // Փ˔
   // Ԃ0`1̊ԂȂΏՓ
   if( *t>=0 && *t<=1 )
      return true; // Փ˕

   // ǂɂ߂荞łԂł
   // ǂ̑Oɉ߂
   if(-Dot<r){
      *pOut_colli = *pPre_pos - Dot*N;
   }

   return false;
}


///////////////////////////////////////////////////
// ʂƋ̏Փˌ㑬xZo֐
// pColliPos : Փ˒̃p[eBN̒Sʒu
// pVelo : Փ˂̏uԂ̃p[eBN̑x
// res : p[eBN̕ǂɑ΂锽
// time : ˌ̈ړ\
// pNormal : ʂ̖@
// pOut_pos : p[eBN̔ˌʒu
// pOut_velo : p[eBN̔ˌ㑬xxNg

bool CalcParticlePlaneAfterPos(
	D3DXVECTOR3 *pColliPos,
	D3DXVECTOR3 *pVelo,
	FLOAT res,
	FLOAT time,
	D3DXVECTOR3 *pNormal,
	D3DXVECTOR3 *pOut_pos,
	D3DXVECTOR3 *pOut_velo
)
{
	// ˌ㑬xZo
	D3DXVECTOR3 N;
	D3DXVec3Normalize(&N,pNormal);
	*pOut_velo = *pVelo - (1+res)*D3DXVec3Dot(&N,pVelo)*N;

	// ړʒuvZ
	*pOut_pos = *pColliPos + *pOut_velo * time;

	return true;
}


}	// end namespace IKD